From faddb5d41ec83bc8633f60e36ed9c8e03744ffd5 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 735/1001] Move widget templates inside the widget directory


---

diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index aa8ff61..1a8cc50 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -22,7 +22,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/about.html"
+    template_name = "about.html"
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 3664ae5..6c76716 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -25,7 +25,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/badges.html"
+    template_name = "badges.html"
 
     def get_context(self, instance, *args, **kwargs):
         context = {"title": "Badges"}
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index ecccf46..9123a4d 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -3,6 +3,8 @@ from __future__ import unicode_literals, absolute_import
 import collections
 import logging
 import re
+import flask
+import jinja2
 
 from importlib import import_module
 from .caching import CachedFunction
@@ -33,6 +35,9 @@ class Widget(object):
     position = None
     arguments = []
 
+    def __init__(self):
+        self._template_environment = None
+
     def validate(self):
         """Ensure that the widget has the bits it needs."""
         if self.name is None:
@@ -60,13 +65,26 @@ class Widget(object):
     def get_template_environment(self):
         """
         Get the template environment that widget-specific views will use.
+
+        If additional filters or variables are needed in the templates, they
+        can be added by overriding this method in the widget subclass.
         """
-        # We may have widget-specific template environment one day
-        # (when widget templates are stored in the widget's directory
-        # instead of a common widget template directory).
-        # When that happens, it should be cached in a Widget attribute.
-        from hubs.widgets.templating import environment
-        return environment
+        if self._template_environment is None:
+            env = jinja2.Environment(
+                loader=jinja2.ChoiceLoader([
+                    jinja2.PackageLoader(self.__module__, "templates"),
+                    jinja2.PackageLoader("hubs.widgets", "templates"),
+                    ]),
+                trim_blocks=True,
+            )
+            env.filters['tojson'] = flask.json.tojson_filter
+            env.globals.update({
+                'session': flask.app.session,
+                'g': flask.g,
+                'url_for': flask.url_for,
+                })
+            self._template_environment = env
+        return self._template_environment
 
     def _get_local_subclasses(self, parent_class):
         """
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 6a27bec..5965be1 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -28,7 +28,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/bugzilla.html"
+    template_name = "bugzilla.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/contact/__init__.py b/hubs/widgets/contact/__init__.py
index c491eb3..f5e5722 100644
--- a/hubs/widgets/contact/__init__.py
+++ b/hubs/widgets/contact/__init__.py
@@ -21,7 +21,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/contact.html"
+    template_name = "contact.html"
 
     def get_context(self, instance, *args, **kwargs):
         ''' Data for Contact widget. Checks if the hub associated
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index 1a96ee5..19d43c4 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -21,7 +21,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/dummy.html"
+    template_name = "dummy.html"
 
     def get_context(self, instance, *args, **kwargs):
         return dict(
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 82f68c1..a557148 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -30,7 +30,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/fedmsgstats.html"
+    template_name = "fedmsgstats.html"
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index d2601f1..bd35b61 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -32,7 +32,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/feed.html"
+    template_name = "feed.html"
 
     def get_context(self, instance, *args, **kwargs):
         # Avoid circular import
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 3c55f9c..2c9d26c 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -31,7 +31,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/fedorahosted.html"
+    template_name = "fhosted.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_tickets = GetTickets(instance)
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 9a03bc5..8b9aab3 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -37,7 +37,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/github_pr.html"
+    template_name = "github_pr.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index e70dabf..6af020d 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -37,7 +37,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/githubissues.html"
+    template_name = "githubissues.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index af990ac..d15fa1d 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -24,7 +24,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/library.html"
+    template_name = "library.html"
 
     def get_context(self, instance, *args, **kwargs):
         urls = [
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index adc9590..f745e28 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -21,7 +21,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/linechart.html"
+    template_name = "linechart.html"
 
     def get_context(self, instance, *args, **kwargs):
         username = instance.config["username"]
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 8a5c7ef..c87df27 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -41,7 +41,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/meetings.html"
+    template_name = "meetings.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_meetings = GetMeetings(instance)
diff --git a/hubs/widgets/memberships/__init__.py b/hubs/widgets/memberships/__init__.py
index cd36983..213f024 100644
--- a/hubs/widgets/memberships/__init__.py
+++ b/hubs/widgets/memberships/__init__.py
@@ -18,7 +18,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/memberships.html"
+    template_name = "memberships.html"
 
     def get_context(self, instance, *args, **kwargs):
         hub = instance.hub
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index ad047a7..580fece 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -27,7 +27,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/pagure_pr.html"
+    template_name = "pagure_pr.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 690dd86..f3490c9 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -27,7 +27,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/pagureissues.html"
+    template_name = "pagureissues.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_issues = GetIssues(instance)
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 84b2016..e4e874c 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -46,7 +46,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/rules.html"
+    template_name = "rules.html"
 
     def get_context(self, instance, *args, **kwargs):
         owners = instance.hub.owners
diff --git a/hubs/widgets/stats/__init__.py b/hubs/widgets/stats/__init__.py
index 87d4415..67740df 100644
--- a/hubs/widgets/stats/__init__.py
+++ b/hubs/widgets/stats/__init__.py
@@ -17,7 +17,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/stats.html"
+    template_name = "stats.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_stats = GetStats(instance)
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 28c8fed..02e7fdf 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -22,7 +22,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/sticky.html"
+    template_name = "sticky.html"
 
     def get_context(self, instance, *args, **kwargs):
         # TODO -- render with markdown
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 466beb9..14538f0 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -31,7 +31,7 @@ class BaseView(WidgetView):
 
     name = "root"
     url_rules = ["/"]
-    template_name = "templates/subscriptions.html"
+    template_name = "subscriptions.html"
 
     def get_context(self, instance, *args, **kwargs):
         context = dict(title="Hubs")
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 572b670..05a633a 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -31,7 +31,8 @@ class WidgetView(View):
         url_rules (list): A list of URL rules that this view must be registered
             for (like the `rule` parameter of Flask's `add_url_rule()`).
         template_name (str): The template name to use for this view. It will be
-            looked for in the widget's template environment.
+            looked for in the widget's `templates` subdirectory first, and
+            then in the global `hubs/widgets/templates/` directory.
 
     This class is Flask-specific. If another framework were to be switched to,
     it would have to be re-implemented.
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index cc4cb3a..5d891e0 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -27,7 +27,7 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
-    template_name = "templates/workflow/pendingacls.html"
+    template_name = "pendingacls.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_pending = GetPending(instance)
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 00df8fc..d2490a3 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -31,7 +31,7 @@ class BaseView(WidgetView):
     name = "root"
     url_rules = ["/"]
     # TODO -- add approve/deny buttons or just link through to pkgdb
-    template_name = "templates/workflow/updates2stable.html"
+    template_name = "updates2stable.html"
 
     def get_context(self, instance, *args, **kwargs):
         get_pending = GetPending(instance)

